import csv

def avg(l):
    try:
        return str(round(sum(l)/len(l), 2))
    except:
        return "0"


times = [ [], [], [], [], [], [] ]
snts = [ ]
notempty = [ ]


with open('webextractor.log', 'rt') as csvfile:
    reader = csv.reader(csvfile, delimiter=',', quoting=csv.QUOTE_NONE)
    for row in reader:
        tipe = int(row[1])

        times[tipe].append(float(row[4]))

        if tipe == 0:
            snts.append(int(row[2]))
            notempty.append(int(row[3]))

words = 0
rels = -2
with open('./data/memory.txt', 'rt') as memfile:
    for line in memfile:
        if line[0:4] == 'WORD':
            words = words + 1
        else:
            rels = rels + 1
        
            

ts = 0
ss = 0
for i in times:
    ts += len(i)
    ss += sum(i)


mins, secs = divmod(ss, 60)
hours, mins = divmod(mins, 60)
hh = '%02d:%02d:%02d' % (hours, mins, secs)


print "TOTAL processed pages:" + str(ts) + " / time " + hh + " / " + str(round(ss/ts,2)) + " avg page secs"
print "Words: " + str(words) + " Rels: " + str(rels)
print
print "OK    total=" + str(len(times[0])) + " avgtime=" + avg(times[0]) + " snts=" + str(sum(snts)) + "/" + avg(snts) + " withrels=" + str(sum(notempty)) + "/" + avg(notempty) + "  %" + str((len(times[0])*100)/ts)
print "404   total=" + str(len(times[1])) + " avgtime=" + avg(times[1]) + "  %" + str((len(times[1])*100)/ts)
print "Error total=" + str(len(times[2])) + " avgtime=" + avg(times[2]) + "  %" + str((len(times[2])*100)/ts)
print "Empty total=" + str(len(times[3])) + " avgtime=" + avg(times[3]) + "  %" + str((len(times[3])*100)/ts)
print "NoEng total=" + str(len(times[4])) + " avgtime=" + avg(times[4]) + "  %" + str((len(times[4])*100)/ts)
print "NoHTM total=" + str(len(times[5])) + " avgtime=" + avg(times[5]) + "  %" + str((len(times[5])*100)/ts)
print



        

