# http://aseryla.16mb.com/DATA_Extraction.html
# [Crawling the web] section
#
# Tool for cleaning the memory, removing concepts under the following criteria:
# - large specializations (e.g.: mark_jhonson_steven_turner_paul_nigh)
# - Remove NER concepts (E.g.: the concept "paris" as "paris isa location"; "Mike" due to "mike isa person")
# - concepts with only NER or specilization relations
#     E.g:
#     football_team ISA team 
#     soocer_team ISA team 
#     soccer_team HAVE player
#     paul ISA person 
#     mark ISA person
#     mark IS nice
#     new_york_city ISA city
#     new_york_city ISA location
#     --> the concepts "football_team, paul and new_york_city" are removed
#
# No input parameters are required, the original file remains untouched
# The new memory file is saved in "memory_cleaned.txt"
#
# For a fully cleaning, it's needed to apply the "aseryla memory arrange" (http://aseryla.16mb.com/APP_starting.html#memclean)
# throug [@v 1] command or using the correspondent button that appears in the tab explore of the GUI
#


after = []
level = 0
only_ner_spec = []

current = "person"
curilcs = 0
curisas = 0
curners = 0

print 1

with open('memory.txt', 'rt') as memfile:
    for line in memfile:
        

        if "==" in line[0:6]:
            level = level + 1
            after.append(line)
            continue

        parts = line.split(' ')

        if level == 1: # words

            # filter specializations with more than 3 levels 
            if parts[3].count('_') > 2:
                continue

 
        else: # relations

            # filter specializations with more than 3 levels
            if parts[0].count('_') > 2 or parts[2].count('_') > 2 or parts[3].count('_') > 2:
                continue

            if parts[1] == 'isa' and parts[2] in ["person", "organization", "location"]:
                only_ner_spec.append(parts[0])


            # analyze each concept to determine if all their relation are NER or spec
            if not parts[0] == current:

                if curilcs == (curners + curisas):
                    only_ner_spec.append(current)

                curilcs = 0
                curisas = 0
                curners = 0
                
            current = parts[0]

            if parts[1] == 'isa' and parts[2] in ["person", "organization", "location"]:
                curners = curners + 1
                
            if parts[2] in parts[0].split("_"):
                curisas = curisas + 1

            curilcs = curilcs + 1

                

        after.append(line)

print 2



only_ner_spec = set(only_ner_spec)
level = 0
to_remove = []

outf = open('memory_cleaned.txt', 'wt')

for aa in after:
    if "==" in aa[0:6]:
        level = level + 1
        outf.write(aa)
        continue

    parts = aa.split(' ')
    
    if level == 1 and parts[3] in only_ner_spec:
        continue

    if level == 2:
        
        if parts[0] in only_ner_spec or parts[2] in only_ner_spec:
            continue

        if parts[1] == 'can' and parts[4] != '/':
            interaction = parts[3][0: parts[3].find('*')]
            if interaction in only_ner_spec:
                continue

            

    outf.write(aa)

outf.close()    

         
print "end"            

